Dynamic Link Exchange Protocol (DLEP) IEEE 802.1Q Aware Credit Window Extension
RFC 9895
David Wiggins
Lou Berger
LabN Consulting, L.L.C.
lberger@labn.net
Donald E. Eastlake 3rd, Ed.
Independent
2386 Panoramic Circle
Apopka
FL
32703
United States of America
+1-508-333-2270
d3e3e3@gmail.com
December 2025
RTG
manet
This document defines an extension to the Dynamic Link Exchange Protocol (DLEP) that enables an Ethernet IEEE 802.1Q aware credit window scheme for destination-specific and shared flow control.
Introduction
The Dynamic Link Exchange Protocol (DLEP) is defined in [RFC8175]. The protocol provides the exchange of link-related control information between DLEP peers. DLEP peers consist of a modem and a router. DLEP defines a base set of mechanisms as well as support for possible extensions. This document defines one such extension.
The DLEP specification does not define any flow control mechanisms. While in theory various flow control techniques could be implemented with DLEP, this document specifies a DLEP extension that introduces an Ethernet-based flow control mechanism for traffic transmitted from a router to a modem. This mechanism utilizes one or more logical "credit windows", each of which is typically associated with a virtual or physical queue. The router leverages traffic flow classification information provided by the modem to determine the appropriate credit window for a given traffic flow. Credit windows may be shared across multiple flows or used on a per-flow basis. For a Diffserv-based approach to credit window flow control, refer to [RFC9894]. As specified in Section 2.3.1 of [RFC9892], when both Diffserv and Ethernet traffic classification are applied to a flow, Ethernet-based classification takes precedence.
This document leverages the traffic classification and credit window flow control mechanisms defined in [RFC9892] and [RFC9893] to enable credit-window-based flow control based on DLEP destinations, Ethernet Virtual Local Area Networks (VLANs), and Priority Code Points (PCPs). Ethernet PCP support is specified as part of the IEEE 802.1Q tag format [IEEE8021Q], which includes a 3-bit "PCP" field. The tag format also incorporates a 12-bit "VLAN Identifier (VID)" field.
The defined mechanism allows credit windows to be shared across traffic destined for multiple DLEP destinations, VLANs, and PCPs, or to be dedicated exclusively to traffic associated with a specific destination, VLAN, and/or PCP. Additionally, this extension supports "wildcard" matching for any PCP or VID.
The extension defined in this document is referred to as the "IEEE 802.1Q Aware Credit Window" or, more simply, the "Ethernet Credit" extension. The reader should be familiar with both the traffic classification and credit window flow control mechanisms defined in [RFC9892] and [RFC9893].
This document defines a new DLEP Extension Type value that is used to indicate support for the extension. See Section 2.
Key Words
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Extension Usage and Identification
The extension defined in this document is built on the mechanisms and processing defined in [RFC9892] and [RFC9893]. To indicate that the IEEE 802.1Q Aware Credit Window Extension is to be used, an implementation MUST include the IEEE 802.1Q Aware Credit Window Extension Type value in the Extensions Supported Data Item (see Section 13.6 of [RFC8175]). The Extensions Supported Data Item is sent and processed according to [RFC8175]. Any implementation that indicates the use of the IEEE 802.1Q Aware Credit Window Extension MUST support all message types, Data Items, the Ethernet Traffic Classification Sub-Data Item, and all related processing defined in [RFC9892] and [RFC9893].
The IEEE 802.1Q Aware Credit Window Extension Type value is 5. See Section 5.
Management Considerations
This section provides several network management guidelines for implementations supporting the IEEE 802.1Q Aware Credit Window Extension.
If this extension is supported, that support MUST be declared using the Extensions Supported Data Item (see Section 13.6 of [RFC8175]), which is configurable on both modems and routers. Diffserv Aware Credit Window Extension Data Items MUST NOT be emitted by a DLEP participant unless such support was specified in the initialization message received from its peer. The use of the extension defined in this document SHOULD be configurable on both modems and routers.
Modems SHOULD support the configuration of mapping a PCP to a credit window (queue).
Modems MAY support the configuration of mapping a PCP to a credit window (queue) on a per-VLAN basis. VID value zero (0x0000) is used by [RFC9892] to indicate that the VID is ignored. VID 0xFFFF is reserved. Any other VID value from 0x0001 through 0xFFFE can be used in traffic classification.
When VLANs are supported by a modem without support from PCPs, the modem SHOULD support the configuration of mapping a VLAN to a credit window (queue).
Modems MAY support the configuration of the number of credit windows (queues) that they advertise to a router.
Routers may impose limitations on the number of queues they can support and on the allowable credit window configurations. In some cases, per-destination queues may not be supported. If the credit window information provided by the modem exceeds the router's capabilities, the router SHOULD utilize a subset of the advertised credit windows. Alternatively, the router MAY reset the session and indicate that the extension is not supported. In either case, any mismatch in capabilities SHOULD be reported to the user through standard network management mechanisms, such as user interface notifications or error logging.
Regardless of implementation, if credit windows are in use, the router MUST NOT send traffic to the modem unless sufficient credits are available.
Security Considerations
This document defines a DLEP extension that uses DLEP mechanisms and the credit window flow control mechanisms defined in [RFC9892] and [RFC9893]. See also the Security Considerations sections of those documents.
The defined extension is exposed to vulnerabilities similar to existing DLEP messages and discussed in the Security Considerations section of [RFC8175], such as an injected message resizing a credit window to a value that results in a denial of service. The security mechanisms documented in [RFC8175] can be applied equally to the mechanism defined in this document.
Wildcards for matching PCP and VID fields are provided. Note that wildcards may be convenient for matching a number of packet flows but could inadvertently match unexpected flows or new flows that appear after the wildcard matching has been set up. It is therefore RECOMMENDED that wildcards not be used unless clearly needed.
IANA Considerations
IANA has assigned the following code point in the "Extension Type Values" registry in the "Dynamic Link Exchange Protocol (DLEP) Parameters" registry group:
Extension Type Value
Code | Description
5 | IEEE 802.1Q Aware Credit Window
References
Normative References
[IEEE8021Q]

IEEE Standard for Local and Metropolitan Area Networks--Bridges and Bridged Networks
IEEE
December 2022
DOI 10.1109/IEEESTD.2022.10004498
IEEE Std 802.1Q-2022
[RFC9893]

Dynamic Link Exchange Protocol (DLEP) Credit-Based Flow Control Messages and Data Items
Bow-Nan Cheng
MIT Lincoln Laboratory
David Wiggins
Stan Ratliff
Lou Berger
LabN Consulting, L.L.C.
Eric Kinzie, Ed.
LabN Consulting, L.L.C.
December 2025
RFC 9893
DOI 10.17487/RFC9893
[RFC9892]

Dynamic Link Exchange Protocol (DLEP) Traffic Classification Data Item
Bow-Nan Cheng
MIT Lincoln Laboratory
David Wiggins
Lou Berger
LabN Consulting, L.L.C.
Don Fedyk, Ed.
LabN Consulting, L.L.C.
December 2025
RFC 9892
DOI 10.17487/RFC9892
Informative References
[RFC9894]

Dynamic Link Exchange Protocol (DLEP) Diffserv Aware Credit Window Extension
Bow-Nan Cheng
MIT Lincoln Laboratory
David Wiggins
Lou Berger
LabN Consulting, L.L.C.
Donald E. Eastlake 3rd, Ed.
Independent
December 2025
RFC 9894
DOI 10.17487/RFC9894
[RFC8175]
[RFC2119]
[RFC8174]
Acknowledgments
This document was motivated by discussions in the MANET Working Group. Many useful comments were received from contributors to the MANET Working Group, notably Ronald in 't Velt.
We had the honor of working too briefly with David Wiggins on this and related DLEP work. His contribution to the IETF and publication of the first and definitive open-source DLEP implementation have been critical to the acceptance of DLEP. We mourn his passing on November 26, 2023. We wish to recognize his guidance, leadership, and professional excellence. We were fortunate to benefit from his leadership and friendship. He shall be missed.